// 子集 II
// 给你一个整数数组 nums ，其中可能包含重复元素，请你返回该数组所有可能的子集（幂集）。
// 解集 不能 包含重复的子集。返回的解集中，子集可以按 任意顺序 排列。
// https://leetcode-cn.com/problems/subsets-ii/

//Rust实现
pub fn dfs(ret: &mut Vec, nums: &Vec, cur: &mut Vec, start: usize) {
        ret.push(cur.clone());
        for i in start..nums.len() {
            if i > start && nums[i] == nums[i - 1] {
                continue;
            }
            cur.push(nums[i]);
            dfs(ret, nums, cur, i + 1);
            cur.pop();
        }
    }
impl Solution {
     pub fn subsets_with_dup(nums: Vec<i32>) -> Vec<Vec<i32>> {
        nums.sort_unstable();
        let mut cur = vec![];
        let mut ret = vec![];
        dfs(&mut ret, &nums, &mut cur, 0);
        ret
    }
}

// C++实现
// class Solution {
// public:
//     vector<vector<int>> subsetsWithDup(vector<int>& nums) {
//         ret.push_back(cur);
//         for (int i = start; i < nums.size(); i++) {
//             if (i > start && nums[i] == nums[i - 1]) continue;
//             cur.push_back(nums[i]);
//             dfs(cur, nums, i + 1);
//             cur.pop_back();
//         }
//     }
//     vector> subsetsWithDup(vector& nums) {
//         sort(nums.begin(), nums.end());
//         vectorcur;
//         dfs(cur, nums, 0);
//         return ret;
//     }
// };