//  形成两个异或相等数组的三元组数目
// 给你一个整数数组 arr 。
// 现需要从数组中取三个下标 i、j 和 k ，其中 (0 <= i < j <= k < arr.length) 。
// a 和 b 定义如下：
// a = arr[i] ^ arr[i + 1] ^ ... ^ arr[j - 1]
// b = arr[j] ^ arr[j + 1] ^ ... ^ arr[k]
// 注意：^ 表示 按位异或 操作。
// 请返回能够令 a == b 成立的三元组 (i, j , k) 的数目。
//https://leetcode-cn.com/problems/count-triplets-that-can-form-two-arrays-of-equal-xor/
//Rust实现
use std::collections::HashMap;
impl Solution {
    pub fn count_triplets(arr: Vec) -> i32 {
        let n = arr.len();
        let mut cnt = HashMap::new();
        let mut total = HashMap::new();
        let mut ans = 0;
        let mut s = 0;
        for k in 0..n {
            let s_nxt = s ^ arr[k];
            if let Some(&cnt_val) = cnt.get(&s_nxt) {
                ans += cnt_val * k - *total.entry(s_nxt).or_insert(0);
            }
            *cnt.entry(s).or_insert(0) += 1;
            *total.entry(s).or_insert(0) += k;
            s = s_nxt;
        }
        ans as i32
    }
} 
//C++实现
// class Solution {
// public:
//     int countTriplets(vector &arr) {
//         int n = arr.size();
//         unordered_mapcnt, total;
//         int ans = 0, s = 0;
//         for (int k = 0; k < n; ++k) {
//             int s_nxt = s ^ arr[k];
//             if (cnt.find(s_nxt) != cnt.end()) {
//                 ans += cnt[s_nxt] * k - total[s_nxt];
//             }
//             ++cnt[s];
//             total[s] += k;
//             s = s_nxt;
//         }
//         return ans;
//     }
// }; 
