// 27. 移除元素
// 给你一个数组 nums 和一个值 val，你需要 原地 移除所有数值等于 val 的元素，并返回移除后数组的新长度。
// 不要使用额外的数组空间，你必须仅使用 O(1) 额外空间并 原地 修改输入数组。
// 元素的顺序可以改变。你不需要考虑数组中超出新长度后面的元素。
//https://leetcode-cn.com/problems/remove-element/submissions

//Rust实现
impl Solution {
   pub fn remove_element(nums: &mut Vec<i32>, val: i32) -> i32 {
       let mut left = 0;
       while left < nums.len() && nums.len() > 0 {
           if nums[left] == val {
               nums.swap_remove(left);
           } else {
               left += 1;
           }
       }
       nums.len() as i32
   }
}

//C++实现
// class Solution {
// public:
//    int removeElement(vector<int>& nums, int val) {
//        int i = 0;
//        for (int j = 0; j < nums.size(); j++) {
//                if (nums[j] != val) {
//                nums[i] = nums[j];
//                i++;
//            }
//        }
//        return i;
//    }
// };