# Notes

- [Notes](#notes)
  - [传播错误](#传播错误)
    - [panic!](#panic!)
    - [Result](#Result)

## 传播错误
### panic!
- 示例、代码原型、测试用panic!\unwrap\expect
### Result
实际项目中应该用Result
```
use std::io;
use std::io::Read;
use std::fs::File;
fn main() {
    let r = read_username_from_file() ;
    match r {
        0k(s) => println! ("S = {}",s) ,
        Err(e) => println!("err = {:?}", e),
    }
}
fn read_username_from_ file() -> Result<String, io: :Error> {
    let mut s = String::new() ;
    File::open( "hello. txt")?.read_ to_ string(&mut s)?;
    0k(s)
}
```
