// 70. 爬楼梯
// 假设你正在爬楼梯。需要 n 阶你才能到达楼顶。
// 每次你可以爬 1 或 2 个台阶。你有多少种不同的方法可以爬到楼顶呢？
// 注意：给定 n 是一个正整数。
//https://leetcode-cn.com/problems/climbing-stairs/submissions/

//Rust实现
impl Solution {
    pub fn climb_stairs(n: i32) -> i32 {
     if n <= 1 {
            return n;
        }
        let mut dp = vec![0;(n+1) as usize];
        dp[1] = 1;
        dp[2] = 2;
        for i in 3..(n+1) {
            dp[i as usize] = dp[(i - 1) as usize] + dp[(i - 2) as usize];
        }
       return dp[n as usize];
    }
}
//C实现
// int climbStairs(int n){
//     if(n==1)
//         return 1;
//     int a = 1;
//     int b = 2;
//     int c;
//     for(int i=3;i<=n ;++i){
//         c = a + b;
//         a = b;
//         b = c;
//     }
//     return b;
// }