// 15. 三数之和
// 给你一个包含 n 个整数的数组 nums，判断 nums 中是否存在三个元素 a，b，c ，使得 a + b + c = 0 ？请你找出所有和为 0 且不重复的三元组。
// 注意：答案中不可以包含重复的三元组。
// https://leetcode-cn.com/problems/3sum/

// Rust实现
impl Solution {
    pub fn three_sum(nums: Vec<i32>) -> Vec<Vec<i32>> {
        let mut ret: std::collections::HashSet<Vec<i32>> = std::collections::HashSet::new();

        for (i, a) in nums.iter().enumerate() {
            let target = 0 - *a;
            let mut temp: std::collections::HashMap<i32, i32> = std::collections::HashMap::new();

            for b in &nums[i + 1..] {
                match temp.get(b) {
                    Some(&c) => {
                        let mut vtemp = vec![*a, *b, c];
                        vtemp.sort();
                        ret.insert(vtemp);
                    }
                    None => {
                        temp.insert(target - *b, *b);
                    }
                }
            }
        }
        ret.into_iter().collect()
    }
}


// C++实现
// class Solution {
// public:
//     vector<vector<int>> threeSum(vector<int>& nums) {
// 	vector<vector<int>>res;
// 	sort(nums.begin(), nums.end());
// 	int n = nums.size();
// 	for (int i = 0; i < n - 2; i++)
// 	{
// 		int L = i + 1;
// 		int R = n - 1;
// 		if (nums[i] > 0) continue;
// 		while (L < R) {
// 			if (nums[i] + nums[L] + nums[R] == 0) {
// 				vector<int> resList = { nums[i],nums[L],nums[R] };
// 				res.push_back(resList);
// 			}
// 			if (nums[i] + nums[L] + nums[R] <= 0) {
// 				while (L <= n - 2 && nums[L] == nums[L + 1])
// 					L++;
// 				L++;
// 			}
// 			else {
// 				while (R >= 1 && nums[R] == nums[R - 1])
// 					R--;
// 				R--;
// 			}
// 		}
// 		while (i < n - 1 && nums[i] == nums[i + 1])
// 			i++;
// 	}
// 	return res;
// }

// };